import { ChangeDetectorRef, ElementRef, OnInit } from '@angular/core';
import { Emoji, EmojiService } from 'ngx-emoji-mart-picker/ngx-emoji';
import { EmojiFrequentlyService } from './emoji-frequently.service';
export declare class CategoryComponent implements OnInit {
    ref: ChangeDetectorRef;
    private emojiService;
    private frequently;
    emojis?: any[] | null;
    hasStickyPosition: boolean;
    name: string;
    perLine: number;
    totalFrequentLines: number;
    recent: string[];
    custom: any[];
    i18n: any;
    id: any;
    hideObsolete: boolean;
    notFoundEmoji?: string;
    emojiIsNative?: Emoji['isNative'];
    emojiSkin?: Emoji['skin'];
    emojiSize?: Emoji['size'];
    emojiSet?: Emoji['set'];
    emojiSheetSize?: Emoji['sheetSize'];
    emojiForceSize?: Emoji['forceSize'];
    emojiTooltip?: Emoji['tooltip'];
    emojiBackgroundImageFn?: Emoji['backgroundImageFn'];
    emojiOver: Emoji['emojiOver'];
    emojiLeave: Emoji['emojiLeave'];
    emojiClick: Emoji['emojiClick'];
    container: ElementRef;
    label: ElementRef;
    containerStyles: any;
    labelStyles: any;
    labelSpanStyles: any;
    margin: number;
    minMargin: number;
    maxMargin: number;
    top: number;
    constructor(ref: ChangeDetectorRef, emojiService: EmojiService, frequently: EmojiFrequentlyService);
    ngOnInit(): void;
    memoizeSize(): void;
    handleScroll(scrollTop: number): boolean;
    getEmojis(): any[];
    updateDisplay(display: 'none' | 'block'): void;
    trackById(index: number, item: any): any;
}
